Bug 505207 - R200 GPU hang when Firefox attempts to display a huge image
R200 GPU hang when Firefox attempts to display a huge image
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-ati (Show other bugs)
11
All Linux
low Severity urgent
: ---
: ---
Assigned To: Dave Airlie
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-06-10 21:33 EDT by Nicholas Miell
Modified: 2009-11-27 07:46 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-27 07:27:16 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
dmesg (28.69 KB, text/plain)
2009-06-12 12:42 EDT, Nicholas Miell
no flags Details
xorg.conf (1.05 KB, text/plain)
2009-06-12 12:43 EDT, Nicholas Miell
no flags Details
Xorg.0.log (65.80 KB, text/plain)
2009-06-12 12:44 EDT, Nicholas Miell
no flags Details
example page mentioned by the reporter (13.91 MB, application/zip)
2009-06-12 20:18 EDT, Matěj Cepl
no flags Details

  None (edit)
Description Nicholas Miell 2009-06-10 21:33:34 EDT
Description of problem:
When Firefox attempts to display a huge image, the GPU hangs.

This may be a duplicate of bug 501095.

Version-Release number of selected component (if applicable):
kernel-2.6.29.4-167.fc11.x86_64
xorg-x11-server-Xorg-1.6.1.901-1.fc11.x86_64
xorg-x11-drv-ati-6.12.2-14.fc11.x86_64
firefox-3.5-0.20.beta4.fc11.x86_64

How reproducible:
Always

Steps to Reproduce:
1. Load a web page in Firefox with a huge image
  
Actual results:
GPU hangs

Expected results:
GPU doesn't hang

Additional info:
The image in question is a 30,000 by 926 JPEG.

The graphics card is:
01:00.0 VGA compatible controller: ATI Technologies Inc Radeon R200 QH [Radeon 8500] (rev 80)
This is an ATI FireGL 8800 with 128 MB of RAM.

Infinite loop with ioctl() returning EAGAIN, stack trace is:
#0  0x000000388bed66c7 in ioctl () from /lib64/libc.so.6
#1  0x00000038a4e03113 in drmIoctl (fd=8, request=3221775460, arg=0x7ffff83e6250) at xf86drm.c:187
#2  0x00000038a4e0335c in drmCommandWriteRead (fd=8, drmCommandIndex=<value optimized out>, 
    data=0x7ffff83e6250, size=<value optimized out>) at xf86drm.c:2363
#3  0x00007f62ef4e2778 in radeon_bufmgr_gem_wait_rendering (buf=<value optimized out>)
    at radeon_bufmgr_gem.c:282
#4  0x00007f62ef4c8e1a in RADEONPrepareAccess (pPix=0x264a8b0, index=0) at radeon_exa.c:279
#5  0x00007f62ef0233b4 in ExaDoPrepareAccess (pDrawable=0x264a8b0, index=0) at exa.c:523
#6  0x00007f62ef0234b8 in exaPrepareAccessReg (pDrawable=0x264a8b0, index=0, pReg=0x0) at exa.c:543
#7  0x00007f62ef02be5c in ExaCheckComposite (op=<value optimized out>, pSrc=0x1b1d520, 
    pMask=0x24f57f0, pDst=0x1dd6000, xSrc=<value optimized out>, ySrc=<value optimized out>, xMask=0, 
    yMask=0, xDst=0, yDst=0, width=170, height=2) at exa_unaccel.c:342
#8  0x00007f62ef02a504 in exaComposite (op=<value optimized out>, pSrc=0x1b1d520, pMask=0x24f57f0, 
    pDst=0x1dd6000, xSrc=<value optimized out>, ySrc=<value optimized out>, xMask=0, yMask=0, xDst=0, 
    yDst=0, width=170, height=2) at exa_render.c:967
#9  0x000000000052f0e0 in damageComposite (op=8 '\b', pSrc=<value optimized out>, 
    pMask=<value optimized out>, pDst=0x1dd6000, xSrc=1, ySrc=0, xMask=<value optimized out>, 
    yMask=<value optimized out>, xDst=0, yDst=0, width=170, height=<value optimized out>)
    at damage.c:643
#10 0x000000000052775c in ProcRenderComposite (client=0x13ba150) at render.c:720
#11 0x0000000000446ee4 in Dispatch () at dispatch.c:437
#12 0x000000000042d0d5 in main (argc=<value optimized out>, argv=0x7ffff83e6828, 
    envp=<value optimized out>) at main.c:397
Comment 1 Matěj Cepl 2009-06-12 09:56:34 EDT
Thanks for the bug report.  We have reviewed the information you have provided above, and there is some additional information we require that will be helpful in our diagnosis of this issue.

Please attach your X server config file (/etc/X11/xorg.conf, if available), /var/log/dmesg, and X server log file (/var/log/Xorg.*.log) to the bug report as individual uncompressed file attachments using the bugzilla file attachment link below.

Could you point us to some particular URL, so we have something common to test on?

We will review this issue again once you've had a chance to attach this information.

Thanks in advance.
Comment 2 Nicholas Miell 2009-06-12 12:41:22 EDT
*sigh*

Now I can't reproduce it, either by loading the huge image in isolation or by loading the original page which caused the crash. (Which is very irritating because I managed to crash the GPU twice purely by accident, but I can't do it on demand.)

The page in question was: http://forums.somethingawful.com/showthread.php?threadid=3005551&userid=0&perpage=40&pagenumber=681 (beware, most of the images on that page are hosted on free image hosts and they have a habit of vanishing fairly quickly -- I have a Firefox generated saved "Web page, complete" archived, not that that does me any good now).
Comment 3 Nicholas Miell 2009-06-12 12:42:38 EDT
Created attachment 347611 [details]
dmesg
Comment 4 Nicholas Miell 2009-06-12 12:43:19 EDT
Created attachment 347612 [details]
xorg.conf
Comment 5 Nicholas Miell 2009-06-12 12:44:13 EDT
Created attachment 347613 [details]
Xorg.0.log
Comment 6 Matěj Cepl 2009-06-12 20:18:47 EDT
Created attachment 347688 [details]
example page mentioned by the reporter

(In reply to comment #2)
> The page in question was:
> http://forums.somethingawful.com/showthread.php?threadid=3005551&userid=0&perpage=40&pagenumber=681
> (beware, most of the images on that page are hosted on free image hosts and
> they have a habit of vanishing fairly quickly -- I have a Firefox generated
> saved "Web page, complete" archived, not that that does me any good now).  

So, let's see what our bugzilla can handle :)
Comment 8 Nicholas Miell 2009-06-24 17:22:42 EDT
Happened again, this time with xorg-x11-drv-ati-6.12.2-17.fc11.x86_64 and a more reasonably sized 3128 by 4676 JPEG. This time I couldn't ssh in remotely to collect any debugging information and I still can't reproduce it.
Comment 9 Martin F 2009-06-30 21:54:10 EDT
I have a similar problem with ATI Radeon Express 200M on an HP laptop.

The GUI freezes except the mouse cursor moves fine, but no response from clicks. The keyboard is completely frozen, since CapsLock light doesn't work at all.

xorg-x11-drv-ati-6.12.2-14.fc11.x86_64
firefox-3.5-0.20.beta4.fc11.x86_64

I can ssh into the system from another PC fine, and can kill firefox process and do other stuff from the command line over the network. But nothing changes in the graphics, so it is GPU and keyboard that are frozen. Note that the other PC that is working fine uses the same exact Fedora 11 with same exact packages and updates, but it has nvidia video proprietary driver.

My ~/.xsession-errors shows:

Window manager warning: Buggy client sent a _NET_ACTIVE_WINDOW message with a ti
mestamp of 0 for 0x3600049 (Mozilla Fi)
Window manager warning: meta_window_activate called by a pager with a 0 timestam
p; the pager needs to be fixed.

(firefox:2349): Gdk-WARNING **: XID collision, trouble ahead

But no error messages in /var/log/Xorg.0.log or /var/log/messages.

One other thing (I'm not sure it's related) is when trying to list the home directory from the command line, I sometimes get:

% ls
% ls
ls: cannot access .gvgs: Permission denied
...
d????????? ?     ?       ?        ? .gvfs
...

But now it's listing fine again.
Comment 10 Nicholas Miell 2009-06-30 23:24:54 EDT
(In reply to comment #9)
> One other thing (I'm not sure it's related) is when trying to list the home
> directory from the command line, I sometimes get:
> 
> % ls
> % ls
> ls: cannot access .gvgs: Permission denied
> ...
> d????????? ?     ?       ?        ? .gvfs
> ...
> 
> But now it's listing fine again.  

This is normal behavior for FUSE mount points and can safely be ignored.
Comment 11 Martin F 2009-06-30 23:38:47 EDT
(In reply to comment #10)
> (In reply to comment #9)
> > ...
> > d????????? ?     ?       ?        ? .gvfs
> > ...
> This is normal behavior for FUSE mount points and can safely be ignored.  

Thanks.

I just heard firefox 3.5 released hours ago. I'll wait for it to appear in fedora repository and see how it goes.
Comment 12 Johannes Maybaum 2009-07-17 09:45:17 EDT
I see the same symptoms as #9 also on a HP Laptop with ATI Radeon Express 200M.
Freeze is easily reproduceable using firefox. Opening a new tab in a reasonable large window does the trick.
Comment 13 Jérôme Glisse 2009-10-15 11:00:35 EDT
Do you still have this issue with fedora 12 (you can test livecd from http://alt.fedoraproject.org/pub/alt/nightly-composes/desktop/) ?
Comment 14 Matěj Cepl 2009-11-05 13:31:12 EST
Since this bugzilla report was filed, there have been several major updates in various components of the Xorg system, which may have resolved this issue. Users who have experienced this problem are encouraged to upgrade their system to the latest version of their packages. For packages from updates-testing repository you can use command

yum upgrade --enablerepo='*-updates-testing'

Alternatively, you can also try to test whether this bug is reproducible with the upcoming Fedora 12 distribution by downloading LiveMedia of F12 Beta available at http://alt.fedoraproject.org/pub/alt/nightly-composes/ . By using that you get all the latest packages without need to install anything on your computer. For more information on using LiveMedia take a look at https://fedoraproject.org/wiki/FedoraLiveCD .

Please, if you experience this problem on the up-to-date system, let us now in the comment for this bug, or whether the upgraded system works for you.

If you won't be able to reply in one month, I will have to close this bug as INSUFFICIENT_DATA. Thank you.

[This is a bulk message for all open Fedora Rawhide Xorg-related bugs. I'm adding myself to the CC list for each bug, so I'll see any comments you make after this and do my best to make sure every issue gets proper attention.]
Comment 15 Johannes Maybaum 2009-11-27 02:32:17 EST
Tested F12 on the same Laptop as in my comment #12.
This issue seems to be fixed, i have not experienced such a hang/crash since i installed F12.
Comment 16 Nicholas Miell 2009-11-27 03:41:49 EST
I have been experiencing hard locks, but there's no rhyme or reason to them and large images certainly aren't involved, so this bug doesn't appear to be an issue in F12.
Comment 17 Matěj Cepl 2009-11-27 07:27:16 EST
Thank you for letting us know.

Note You need to log in before you can comment on or make changes to this bug.